package com.cwbuyer.lib;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import com.cwbuyer.code.AddPpri;
import com.cwbuyer.main.ManageItem;
import com.pwbuyer.main.R;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.database.sqlite.SQLiteDatabase;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;

public class DateUtil {
	
	// Nɶഫ DateTime
	public static String getDateTime(Calendar calendar1) {
		StringBuilder resultStr = new StringBuilder().append("");
		Integer nYear = calendar1.get(Calendar.YEAR);
		Integer nMonth = calendar1.get(Calendar.MONTH);
		Integer nDay = calendar1.get(Calendar.DAY_OF_MONTH);
		Integer nHour = calendar1.get(Calendar.HOUR_OF_DAY);
		Integer nMinute = calendar1.get(Calendar.MINUTE);
		Integer nSecond = calendar1.get(Calendar.SECOND);
		resultStr = new StringBuilder().append(nYear).append("-")
				.append(Utilis.format(nMonth + 1)).append("-")
				.append(Utilis.format(nDay)).append(" ")
				.append(Utilis.format(nHour)).append(":")
				.append(Utilis.format(nMinute)).append(":")
				.append(Utilis.format(nSecond));
		
		return resultStr.toString();
	}

	/* pӤҮtѼ */
	public static long computerDiffTime(Calendar calendar1, Calendar calendar2) {
		long d1 = calendar1.getTimeInMillis() / 1000;
		long d2 = calendar2.getTimeInMillis() / 1000;
		long sec = 0;

		if (d2 > d1) {
			sec = d2 - d1;
		} else {
			sec = d1 - d2;
		}
		return sec;
	}

	/* NഫString 12:30:01 */
	public static String toTimeFormat(long sec) {
		StringBuffer buf = new StringBuffer();
		int nHour;
		int nMinute;
		
		nHour = (int) (sec / (60 * 60));
		sec = sec % (60 * 60);

		nMinute = (int) (sec / 60);
		sec = sec % 60;

		return buf.append(Utilis.format(nHour)).append(":")
				.append(Utilis.format(nMinute)).append(":")
				.append(Utilis.format((int) sec)).toString();
	}
	
  /* ǤJp20090101ζgB榡rŦpyyyyMMdd^ǤU */
  public static String getNextDate(String date, int period, String format) {
    int mYear = Integer.parseInt(date.substring(0, 4));
    int mMonth = Integer.parseInt(date.substring(4, 6));
    int mDay = Integer.parseInt(date.substring(6, 8));
    java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(format);
    String nextDate = "";
    Calendar calendar = Calendar.getInstance();
    calendar.set(mYear, mMonth - 1, mDay);
    calendar.add(Calendar.DAY_OF_YEAR, period);
    nextDate = sdf.format(calendar.getTime());
    return nextDate;
  }
  
  //oثe
  public static  String getCurrentDate(){
		StringBuilder resultStr = new StringBuilder().append("");
		Calendar c = Calendar.getInstance();
		Integer mYear = c.get(Calendar.YEAR);
		Integer mMonth = c.get(Calendar.MONTH);
		Integer mDay = c.get(Calendar.DAY_OF_MONTH);
		resultStr = new StringBuilder().append(mYear).append("-")
				.append(Utilis.format(mMonth + 1)).append("-").append(Utilis.format(mDay));
		return resultStr.toString();
  }
	
  // ^Ǩtήɶܻ  201206061625000
  public static String getSystemTime(){
	  long currentTimeMillis = System.currentTimeMillis();
	  Date date = new Date(currentTimeMillis);
	  SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yMMddHHmmssSSS");
      String times = simpleDateFormat.format(date);
      return times;
  }

  /* pӤҮtѼ */
  public static int computerDiffDate(long date1, long date2) {
    Calendar calendar1 = Calendar.getInstance();
    calendar1.setTimeInMillis(date1);

    Calendar calendar2 = Calendar.getInstance();
    calendar2.setTimeInMillis(date2);
    /* P_O_P~ */
    int y1 = calendar1.get(Calendar.YEAR);
    int y2 = calendar2.get(Calendar.YEAR);

    int d1 = calendar1.get(Calendar.DAY_OF_YEAR);
    int d2 = calendar2.get(Calendar.DAY_OF_YEAR);
    int maxDays = 0;
    int day = 0;
    if (y1 - y2 > 0) {
      maxDays = calendar2.getActualMaximum(Calendar.DAY_OF_YEAR);
      day = d1 - d2 + maxDays;
    } else if (y1 - y2 < 0) {
      maxDays = calendar1.getActualMaximum(Calendar.DAY_OF_YEAR);
      day = d1 - d2 - maxDays;
    } else {
      day = d1 - d2;
    }
    return day;
  }
  
  /* pӤҮtѼ */
  public static long computerDiffTime(long time1, long time2) {
    Calendar calendar1 = Calendar.getInstance();
    calendar1.setTimeInMillis(time1);

    Calendar calendar2 = Calendar.getInstance();
    calendar2.setTimeInMillis(time2);

    long d1 = calendar1.getTimeInMillis() / 1000;
    long d2 = calendar2.getTimeInMillis() / 1000;
    long sec = 0;

    if (d2 > d1) {
      sec = d2 - d1;
    } else {
      sec = d1 - d2;
    }
    
    return sec;
  }

  /* ǤJp20090101^Ǥlong */
  public static long getDateTime(String strDate) {
    return getDateByFormat(strDate, "yyyyMMdd").getTime();
  }

  /* ǤJlongȤή榡rŦpyyyyMMdd */
  public static String getDateTime(String format, long millis) {
    java.util.Calendar calendar = java.util.Calendar.getInstance();
    calendar.setTimeInMillis(millis);
    java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(format);
    return (sdf.format(calendar.getTime()));
  }

  public static int [] showSeason(final Context context,final int vid,final String batchPic,int aYear,int aSeason,final int mode){
	  	final int [] YN={aYear,aSeason};
        String [] mYear = new String[50];
        int addyear = 2012;
        for(int i = 0; i < 50; i ++){
        	mYear[i] = "" + (addyear + i);
        }
    	String[] mSeason = new String[]{"K","L","","V","|u"};
        
	  	
		AlertDialog.Builder dialog = new AlertDialog.Builder(context);
		final View root = ((Activity) context).getLayoutInflater().inflate(R.layout.dlg_season, null);
		ArrayAdapter<CharSequence> adapter = new ArrayAdapter<CharSequence>(context, android.R.layout.simple_spinner_item, mSeason);
		adapter.setDropDownViewResource(R.layout.sst_simple_dropdown_item);
		Spinner spinner = (Spinner)root.findViewById(R.id.spinner_season);
		spinner.setAdapter(adapter);
		spinner.setSelection(aSeason);
		
		ArrayAdapter<CharSequence> adapterYeaer = new ArrayAdapter<CharSequence>(context, android.R.layout.simple_spinner_item, mYear);
		adapter.setDropDownViewResource(R.layout.sst_simple_dropdown_item);
		Spinner spinnerYear = (Spinner)root.findViewById(R.id.spinner_year);
		spinnerYear.setAdapter(adapterYeaer);
		spinnerYear.setSelection(getYearSelect(mYear,aYear));
		// ̦huTӦr
		dialog.setView(root);
		dialog.setTitle("ܦ~שu`");
		dialog.setPositiveButton("OK", new DialogInterface.OnClickListener() {
	          public void onClick(DialogInterface dialog, int which) {
	              String mYear [] = new String[50];
	              int addyear = 2012;
	              for(int i = 0; i < 50; i ++){
	              	mYear[i] = "" + (addyear + i);
	              }
	          		String[] mSeason = new String[]{"K","L","","V","|u"};
	        	  
	        	  Spinner spinnerYear = (Spinner)root.findViewById(R.id.spinner_year);
	        	  Spinner spinner = (Spinner)root.findViewById(R.id.spinner_season);
	        	  int aSeason = spinner.getSelectedItemPosition();
	        	  int aYear = Utilis.toInt(mYear[spinnerYear.getSelectedItemPosition()]);
	        	  YN[0]=aYear;
	        	  YN[1]=aSeason;
	        	  if (mode==0){
	        		  EditText edit = (EditText)((Activity) context).findViewById(vid);
	        		  edit.setText(""+mYear[spinnerYear.getSelectedItemPosition()] + "/"+ mSeason[spinner.getSelectedItemPosition()]);
	        	  }else if (mode==1){
	        		  Button edit = (Button)((Activity) context).findViewById(vid);
		        	  edit.setText(""+mYear[spinnerYear.getSelectedItemPosition()] + "/"+ mSeason[spinner.getSelectedItemPosition()]);
	        	  }else if (mode==2){
						SQLiteDatabase db = Utilis.getDB(context);
						try{
							db.beginTransaction();
							db.execSQL("update qdetail set UNIT2='"+YN[0]+"',SEASON='"+YN[1]+"' where BATCH='"+batchPic+"'");
							db.execSQL("update qitems set YEAR='"+YN[0]+"',SEASON='"+YN[1]+"' where BATCH='"+batchPic+"'");
				            db.setTransactionSuccessful();
						}
						catch(Exception e){
						}finally{
							db.endTransaction();
						}
						db.close();
	        	  }
	          }
		});
		dialog.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
	          public void onClick(DialogInterface dialog, int which) {
	          }
			});
		dialog.show();

		return YN; 
	}
  
  public static int getYearSelect(String mYear[],int year){
  	int index = 0;
  	boolean bFind = false;
  	String strYear = "" + year;
  	for(int i = 0; i < 50  &&  bFind == false; i ++ ){
  		if(mYear[i].equalsIgnoreCase(strYear)){
  			bFind = true;
  			index = i;
  		}
  	}
  	return index;
  }

  
  public static int [] getYearSeason(String format, long millis) {
	  int [] YS={4,2017};
	  
	  
	  
	    return YS;
	  }
  
  public static Date getDateByFormat(String strDate, String format) {
    java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(format);
    try {
      return (sdf.parse(strDate));
    } catch (ParseException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
      return null;
    }
  }
}
