package com.cwbuyer.main;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.cwbuyer.format.EMode;
import com.cwbuyer.lib.Utilis;
import com.cwbuyer.main.APos.PItemKind;
import com.pwbuyer.main.R;

// ƺ޲z
public class DataManage  extends Activity {

	private int nPart=0; //w]0`  1
	private String[] mItem;
	
	Bundle bundle;	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.manage_layout);
//		ParamAdapter adapter = new ParamAdapter(this);
		mItem=new String[]{"|qT","dqT","qT","tӳqT"};		
		
		if (!Utilis.getIni(DataManage.this,"SYS","DEPT",1).equalsIgnoreCase(Utilis.getIni(DataManage.this,"SYS","DEPT",6))){
			nPart=1;  //1. 0.`
			mItem=new String[]{"|qT","dqT","qT"};
		}
		
		DataAdapter adapter = new DataAdapter(this);
		ListView listview = (ListView)findViewById(R.id.listview);
		listview.setAdapter(adapter);
		listview.setOnItemClickListener(new OnItemClickListener(){
			@Override
			public void onItemClick(AdapterView<?> adapter, View view, int pos,
					long arg3) {
				Utilis.runVibrate(DataManage.this);
				Intent intent = new Intent();
				switch(pos){
				case 0: { //|qT
					if (nPart==1) intent.putExtra("qcustf_qkind", PItemKind.TR31); else intent.putExtra("qcustf_qkind", PItemKind.TR30);
					intent.putExtra("qcustf_mode", 0); //
					intent.putExtra("qcustf_key", "888");					
					intent.putExtra("pos_dept",Utilis.getIni(DataManage.this,"SYS","DEPT",1));//zפW"SOS"  N
					intent.setClass(DataManage.this, QCustff.class);
					startActivity(intent);
	            	
				break;				
				}
				
				case 1: { //dqT @b`ܩΪ @P
					intent.setClass(DataManage.this, QCustff.class);
					intent.putExtra("qcustf_mode", 0); //
					intent.putExtra("qcustf_key", "888");					
					intent.putExtra("qcustf_qkind", PItemKind.TR40);
					intent.putExtra("pos_dept",Utilis.getIni(DataManage.this,"SYS","DEPT",6));//zפW"SOS"  N
					startActivity(intent);
					
					break;					
				}
				case 2: { //qT
					
					intent.putExtra("qcustf_qkind", PItemKind.TR20);
					intent.putExtra("qcustf_mode", 0); //
					intent.putExtra("qcustf_key", "");					
					intent.putExtra("pos_dept",Utilis.getIni(DataManage.this,"SYS","DEPT",6));//zפW"SOS"  N
					intent.setClass(DataManage.this, QCustff.class);
					startActivity(intent);
				break;				
				}
				case 3: { 
					if (nPart==0){ //tӳqT
						intent.putExtra("mode", EMode.EDIT);
						intent.putExtra("countryid", 0);
						intent.setClass(DataManage.this, Qfactff.class);
						startActivity(intent);
						
//						intent.putExtra("qcustf_qkind", PItemKind.TR10);
//						intent.putExtra("qcustf_mode", 0); //
//						intent.putExtra("qcustf_key", "888");					
//						intent.setClass(DataManage.this, QCustff.class);
//						startActivity(intent);
					}
				break;				
				}
				default:
				break;				
				} //end_switch
			}
		});
		
		((Button)findViewById(R.id.btn_exit)).setOnClickListener(new MainClick());
	}
	
	class DataAdapter extends BaseAdapter{
		
		private LayoutInflater mInflater;
		
		public DataAdapter(Context context) {
		      /* Ѽƪl */
		      mInflater = LayoutInflater.from(context);
		}
		
		public int getCount() {
			return mItem.length;
		}

		public Object getItem(int position) {
			return position;
		}

		public long getItemId(int position) {
			return position;
		}

		public View getView(int position, View convertView, ViewGroup parent) {
			ViewHolder holder;
			if (convertView == null) {
				convertView = mInflater.inflate(R.layout.list_param, null);
				holder = new ViewHolder();
				holder.textName = (TextView) convertView
						.findViewById(R.id.text_title);
				convertView.setTag(holder);
			} else {
				holder = (ViewHolder) convertView.getTag();
			}
			holder.textName.setText(mItem[position]);
			return convertView;
		}

		/* class ViewHolder */
		private class ViewHolder {
			TextView textName;
		}
	}
	
	class MainClick implements OnClickListener {
		@Override
		public void onClick(View v) {
			Utilis.runVibrate(DataManage.this);
			int id = v.getId();
			switch (id) {
				case R.id.btn_exit:
				{
					finish();
					break;
				}
			}
		}
	}
}
