package com.cwbuyer.main;

import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.ContentValues;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.net.Uri;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.RadioButton;
import android.widget.TextView;
import android.widget.TextView.OnEditorActionListener;
import android.widget.Toast;

import com.cwbuyer.adapter.DateAdapter;
import com.cwbuyer.format.IDialog;
import com.cwbuyer.format.KeySet;
import com.cwbuyer.lib.AppUtil;
import com.cwbuyer.lib.DBCloud;
import com.cwbuyer.lib.DateUtil;
import com.cwbuyer.lib.DialogUtilis;
import com.cwbuyer.lib.PrefKey;
import com.cwbuyer.lib.QMacc;
import com.cwbuyer.lib.QRep_05;
import com.cwbuyer.lib.SQLite;
import com.cwbuyer.lib.Utilis;
import com.cwbuyer.main.APos.PItemKind;
import com.pwbuyer.main.R;

public class MainMenu extends Activity {
	
	DateAdapter mAdapter = null;
	String mac =null;

	protected static final int REFRESH_DATA = 0x00000001;
	String uriAPI=null;
	private String uriAPIpath ="" ;
    String DATABASE_PATH = android.os.Environment.getExternalStorageDirectory().getAbsolutePath();
	
	public ProgressDialog myDialog = null;
	String mCloud="";
	public int CWVersion=22;
	
    @Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		// TODO Auto-generated method stub
		super.onActivityResult(requestCode, resultCode, data);
		if (requestCode == 1001) {
			if (resultCode == RESULT_OK) {
				
			}else{
				finish();
			}
		}
    }
    
    public void onDestroy(){
    	super.onDestroy();
    }
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        setTitle(getString(R.string.app_name_version));
        
        ((LinearLayout)findViewById(R.id.layout_insert)).setOnClickListener(new MainClick());
        ((LinearLayout)findViewById(R.id.layout_psetting)).setOnClickListener(new MainClick());
        ((LinearLayout)findViewById(R.id.layout_csetting)).setOnClickListener(new MainClick());
        ((LinearLayout)findViewById(R.id.layout_manage)).setOnClickListener(new MainClick());
        ((LinearLayout)findViewById(R.id.layout_transfer)).setOnClickListener(new MainClick());
        ((LinearLayout)findViewById(R.id.layout_maintain)).setOnClickListener(new MainClick());
        
        ((Button)findViewById(R.id.btn_tool)).setOnClickListener(new MainClick());
        ((Button)findViewById(R.id.btn_setting)).setOnClickListener(new MainClick());
        ((Button)findViewById(R.id.btn_account)).setOnClickListener(new MainClick());
        ((Button)findViewById(R.id.btn_macc)).setOnClickListener(new MainClick());
        ((Button)findViewById(R.id.btn_clockx)).setOnClickListener(new MainClick());
        ((Button)findViewById(R.id.btn_exit)).setOnClickListener(new MainClick());
//        ((LinearLayout)findViewById(R.id.body)).setBackgroundDrawable(null);
        WifiManager wm = (WifiManager) getSystemService(Context.WIFI_SERVICE);
        mac = wm.getConnectionInfo().getMacAddress();
        	//ˬdO_ҥ
        	//pGINI.SDBҥ
        String DB_CHECK = DATABASE_PATH+File.separator+"CWBuyer";
        File myDataPath = new File(DB_CHECK);
        
        if (myDataPath.exists()){
        	if (!Utilis.getIni(this, "SYS", "IMEI", 1).equalsIgnoreCase("9999999999")){//DnJ
    			String imei [] =Utilis.getIni(this, "SYS", "IMEI", 9).split(",");
        		if(Utilis.getStringSet(this, PrefKey.BEGIN_SSGN,"").equalsIgnoreCase(PrefKey.BEGIN_SIGN)){  //w˫᪺Bҥ
        			//NINIƦs^MEMBER
    		    	Utilis.setStringSet(MainMenu.this, PrefKey.LIMIT_TIME_FIRST,imei[4]); 
    		    	Utilis.setStringSet(MainMenu.this, PrefKey.LIMIT_TIME_LAST,imei[5]);
    		    	Utilis.setStringSet(MainMenu.this, PrefKey.BEGIN_MAC,imei[2]);
    		    	Utilis.putIni(this, "SYS", "IMEI", mac, 4);  
    		    	Utilis.setStringSet(MainMenu.this, PrefKey.BEGIN_SSGN,imei[7]);
				    Utilis.setStringSet(MainMenu.this, PrefKey.LIMIT_TIME_ZONA,imei[0]);		    
				    Utilis.setStringSet(MainMenu.this, PrefKey.LIMIT_TIME_ZONB, imei[1]);
				    Utilis.setStringSet(MainMenu.this, PrefKey.TIME_CHECK_DAY, imei[7]);
				    Utilis.setIntSet(MainMenu.this, PrefKey.PAY_STATE, 1);
        		}else{
        			//`ҰʳqLa
        			//L ˬd DB & PREF eO_@P iHd
        			if(!Utilis.getStringSet(MainMenu.this, PrefKey.LIMIT_TIME_LAST,Utilis.getCurrentDate()).equalsIgnoreCase(imei[5]))
        			{
        				Toast.makeText(MainMenu.this, "tΤwmF,PƮw,iAΫIvD!!", Toast.LENGTH_SHORT).show();        				
        			}
        			Utilis.reCNT(this);
       			}
        	}else{ //nJoxߤ@Ǹ
        		Utilis.putIni(this, "SYS", "IMEI", Utilis.getStringSet(MainMenu.this, PrefKey.LIMIT_TIME_FIRST, Utilis.getCurrentDate()), 5);
        		Utilis.putIni(this, "SYS", "IMEI", Utilis.getStringSet(MainMenu.this, PrefKey.LIMIT_TIME_LAST, Utilis.getCurrentDate()), 6);
        		Utilis.putIni(this, "SYS", "IMEI", Utilis.getStringSet(MainMenu.this, PrefKey.LIMIT_TIME_ZONA, Utilis.getCurrentDate()), 1);
        		Utilis.putIni(this, "SYS", "IMEI", Utilis.getStringSet(MainMenu.this, PrefKey.LIMIT_TIME_ZONB, Utilis.getCurrentDate()), 2);
        		Utilis.putIni(this, "SYS", "IMEI", Utilis.getStringSet(MainMenu.this, PrefKey.BEGIN_MAC, Utilis.getCurrentDate()), 3);
        		Utilis.putIni(this, "SYS", "IMEI", mac, 4);
        		Utilis.putIni(this, "SYS", "IMEI", Utilis.getStringSet(MainMenu.this, PrefKey.TIME_CHECK_DAY, Utilis.getCurrentDate()), 8);
        	}
        	
        	mAdapter = new DateAdapter(this);
		        ListView list = (ListView)findViewById(R.id.list_date);
		        list.setAdapter(mAdapter);
		        list.setOnItemClickListener(new OnItemClickListener(){
					@Override
					public void onItemClick(AdapterView<?> arg0, View arg1, int pos,
							long arg3) {
						// TODO Auto-generated method stub
						Utilis.runVibrate(MainMenu.this);
						Intent intent = new Intent();
						if((!Utilis.getIni(MainMenu.this,"SYS","DEPT",5).equalsIgnoreCase("0") || pos == 0 )){
							intent.putExtra(KeySet.KEY_SEARCH, KeySet.SearchMode.DAY);
						}else if(pos == 1){
							intent.putExtra(KeySet.KEY_SEARCH, KeySet.SearchMode.WEEK);
						}else {
							intent.putExtra(KeySet.KEY_SEARCH, KeySet.SearchMode.MONTH);
						}
						//@@@ӵoiX QPOSFFPέp  MANAGEITEMhʲέp
						//`q~StockManage,ݫw"search_dept"@wnw
						intent.putExtra("search_dept","SOS");  //ťժܥ,@pl]p
						if (!Utilis.getIni(MainMenu.this,"SYS","DEPT",1).equalsIgnoreCase(Utilis.getIni(MainMenu.this,"SYS","DEPT",6))){
							intent.putExtra("QPosff",PItemKind.TR31);//Pf
						}else{
							intent.putExtra("QPosff",PItemKind.TR30);//`Pf
						}
						intent.setClass(MainMenu.this, QPosff.class);
						MainMenu.this.startActivity(intent);
					}
		        });
		        

	        //Mzimport/20123/L
	        File dnPath = new File(android.os.Environment.getExternalStorageDirectory().getAbsolutePath()+File.separator+"CWBuyer/IMPORT/20123");
	        if (!dnPath.exists()){
	        	dnPath.mkdirs();  //Ysb hإߤ
	        }else{
	        	File file[] = dnPath.listFiles();
				for (int i=0; i < file.length; i++)
				{
					if (file[i].getName().indexOf("buyer")>=0){
						Utilis.DeleteFile(dnPath+File.separator+file[i].getName());
					}	
				}
	        }
        	        
	       initPref();
	       
	       initDB();
	        
	
	    	// 2012/06/08
	    	String limitLast = Utilis.getStringSet(MainMenu.this, PrefKey.LIMIT_TIME_LAST, Utilis.getCurrentDate());
	    	
	    	if(Utilis.getIntSet(this,PrefKey.PAY_STATE, 0) == 0){
				setTitle(getString(R.string.app_name_version) + "  եδ:" + limitLast );
			}
	    	// Current  06/08 < 2012/03/08
	    	
	    	if(Utilis.compareTime(limitLast, Utilis.getCurrentDate()) <= 0	){
	    		if(Utilis.getIntSet(this, PrefKey.PAY_STATE, 0) == 0){
	    			setTitle(getString(R.string.app_name_version) + " եΤw");
	    		}
	    	}
	    	
	    		String pass = Utilis.getStringSet(this, PrefKey.PASSWORD, "");
	            if(pass != null && pass.length() > 0){
	            	// ҰʱKXO@
	            	Intent intent = new Intent();
	            	intent.setClass(this, APassword.class);
					MainMenu.this.startActivity(intent);
	            }
	    		if (Utilis.getIni(this,"SYS","DEPT",5).equalsIgnoreCase("0")){
	    			((ListView)findViewById(R.id.list_date)).setVisibility(View.VISIBLE);
	    			mAdapter.refresh(this);
	    		}else
	    			((ListView)findViewById(R.id.list_date)).setVisibility(View.INVISIBLE);
	    		
        }
       }
    
    public void onResume(){
    	super.onResume();
        try {
        	
            String DB_CHECK = DATABASE_PATH+File.separator+"CWBuyer";
            File myDataPath = new File(DB_CHECK);
            
            if (!myDataPath.exists()){

     			DialogUtilis.showDialog(MainMenu.this, "ĵi!!tΦ]䤣ƮwNl", -1,
    				new String[] { "sw(ĵi:즳ƱN)", "iӧֶ}ҤFP,,yAi"}, new IDialog() {
    						@Override
    					public void onDialogFinish(int pos, String choice) {
    						switch (pos) {
    						case 0:
    							initZipPref(); //Y(]cwbuyersb)Ĥ@u
    							break;
    						case 1:
    							finish();
    							break;
    					}	
    				}
    			});
             	
            	//itλ~P Ƨ sb Ӥ޵o?
            	//
    		
            }else {
        	
            	if (Utilis.haveInternet(this)){  //A
            		if ((Utilis.toInt(Utilis.getIni(this, "SYS", "IMEI", 7)) % 66)==0) DBCloud.user_update(this);
            		int of_line=Utilis.toInt(Utilis.getIni(this, "SYS", "IMPORT", 3));
				
					if (of_line!=0){
						String [] imp =Utilis.getIni(this, "SYS", "IMPORT", 9).split(",");
						uriAPIpath = "http://"+imp[0]+"/"+imp[1];
						uriAPI = uriAPIpath+"/mupdate_yn.php";
						mupdate_qc(imp[1],"0","130101");  //iHǦ^server_Q1~Q7updateɶ130801165959
					} 
				}
		    		if (Utilis.getIni(this,"SYS","DEPT",5).equalsIgnoreCase("0")){
		    			((ListView)findViewById(R.id.list_date)).setVisibility(View.VISIBLE);
		    			mAdapter.refresh(this);
		    		}else
		    			((ListView)findViewById(R.id.list_date)).setVisibility(View.INVISIBLE);
		    		
            }	    	
           } catch (Exception e) {
               Log.i("DB", "DB_DIR_Exception: " + e.toString());
           }
    }
    
    private void initDB(){
    	String mDBPath = Utilis.getIni(this, "SYS", "YEAR", 4);
    	SQLite db = new SQLite(this,mDBPath);
    	db.close();
		SQLiteDatabase dbm = Utilis.getDB(MainMenu.this);
        setTitle(getString(R.string.app_name_version)+"DBV."+dbm.getVersion());
        CWVersion=dbm.getVersion();
		dbm.close();
    	db = null;
    }
    
    ProgressDialog mProgress = null;

	private int mDatabaseChoice = 0;
	//Ĥ@NgJl
    private void initZipPref(){
    	
    	
			DialogUtilis.showDialog(MainMenu.this, "PƮwNl", -1,
			new String[] { "w(Y즳ƱNOd)","[Tw]PNsw(M즳)"}, new IDialog() {
					@Override
				public void onDialogFinish(int pos, String choice) {
					switch (pos) {
					case 0:
						finish();
						break;
					case 1:
				    	if((Utilis.getBooleanSet(MainMenu.this, "first_zip_init_preference", false) == false) ){
				    		Utilis.setBooleanSet(MainMenu.this, "first_zip_init_preference",true);
				    		final Handler handler = new Handler(){
								public void handleMessage(Message msg)
								{
									if(msg.what == 0){
									}else if(msg.what == 1){
										mProgress.dismiss();
									}
								}
						    };
						    
						    mProgress = new ProgressDialog(MainMenu.this);
							mProgress.setCancelable(false);
							mProgress.setProgressStyle(ProgressDialog.STYLE_SPINNER);
							mProgress.setMessage("Ĥ@ݸJ,еy...");
							mProgress.show();
							
							handler.postDelayed(new Runnable(){
								public void run(){
									new Thread(){
										public void run(){
										    initPic();							
//											
										    handler.sendEmptyMessage(1);
										}
									}.start();
								}
							}, 2000);
				    	}
						break;
				}	
			}
		});
     	

    	
    }

    
    /*  ~Ϥ[ sdcard  W */
    private void initPic() {
      String ZIP_FILENAME = "cwbuyer_img_wash";

      try {
        File myDataPath = new File(DATABASE_PATH);
        
        if (!myDataPath.exists()) {
          myDataPath.mkdirs();
        }
        
          InputStream is = getResources().openRawResource(R.raw.cwbuyer_img_wash);
          FileOutputStream fos = new FileOutputStream(myDataPath + "/" + ZIP_FILENAME);
          byte[] buffer = new byte[8192];
          int count = 0;
          while ((count = is.read(buffer)) > 0) {
            fos.write(buffer, 0, count);
          }
          fos.close();
          is.close();
          Utilis.Unzip2(myDataPath + "/" + ZIP_FILENAME, DATABASE_PATH );
          Utilis.DeleteFile(myDataPath + "/" + ZIP_FILENAME);
          
          int isError=AppUtil.initPref_err(MainMenu.this,mac,Utilis.getCurrentDate(),1);
	  		Utilis.putIni(this, "SYS", "IMEI", Utilis.getStringSet(MainMenu.this, PrefKey.LIMIT_TIME_FIRST, Utilis.getCurrentDate()), 5);
	  		Utilis.putIni(this, "SYS", "IMEI", Utilis.getStringSet(MainMenu.this, PrefKey.LIMIT_TIME_LAST, Utilis.getCurrentDate()), 6);
	  		Utilis.putIni(this, "SYS", "IMEI", Utilis.getStringSet(MainMenu.this, PrefKey.LIMIT_TIME_ZONA, Utilis.getCurrentDate()), 1);
	  		Utilis.putIni(this, "SYS", "IMEI", Utilis.getStringSet(MainMenu.this, PrefKey.LIMIT_TIME_ZONB, Utilis.getCurrentDate()), 2);
	  		Utilis.putIni(this, "SYS", "IMEI", Utilis.getStringSet(MainMenu.this, PrefKey.BEGIN_MAC, Utilis.getCurrentDate()), 3);
	  		Utilis.putIni(this, "SYS", "IMEI", mac, 4);
	  		Utilis.putIni(this, "SYS", "IMEI", Utilis.getStringSet(MainMenu.this, PrefKey.TIME_CHECK_DAY, Utilis.getCurrentDate()), 8);
          
          initDB();
      } catch (Exception e) {
        Log.i("DB_EXPLORE", "DB_DIR_Exception: " + e.toString());
      }
    }
    
  //pGĤ@NgJl
    private void initPref(){
    	
        int isError=AppUtil.initPref_err(MainMenu.this,mac,Utilis.getCurrentDate(),0);
       	if (isError>0){
    	String ErrorMsg[]={"",
    			getString(R.string.msg_err_1day)+"(1)",
    			getString(R.string.msg_err_1day)+"(2)",
    			"ϥδXk(3),ЬCW:0933811753ȪA",
    			"ϥδXk(4),ЬCW:0933811753ȪA",
    			"CWBuyer(5)z!!XYN,pGN!!ЬCW:0933811753!!",
    			"CWBuyer(6)z!!Xw,pGN!!ЬCW:0933811753!!",
    			"CWBuyer(7)z!!Xw,pGN!!ЬCW:0933811753!!",
    			"CWBuyer(8)z!!Xw,pGN!!ЬCW:0933811753!!"
    			};
		    mProgress = new ProgressDialog(this);
			mProgress.setCancelable(true);
			mProgress.setProgressStyle(ProgressDialog.STYLE_SPINNER);
			mProgress.setMessage(ErrorMsg[isError]+"ERR="+isError);			
			mProgress.show();
       	}
       	
    }

	class MainClick implements OnClickListener {
		@Override
		public void onClick(View v) {
			Utilis.runVibrate(MainMenu.this);
			int id = v.getId();
			switch (id) {
				case R.id.btn_setting:
				{
					Intent  intent = new Intent();
					intent.setClass(MainMenu.this, Setup.class);
					startActivity(intent);
					break;
				}
				case R.id.btn_account:
				{
					Intent  intent = new Intent();
					intent.setClass(MainMenu.this, ManageAccount.class);
					startActivity(intent);
					break;
				}
				case R.id.btn_macc:  //
				{
					Intent intent = new Intent();
					intent.setClass(MainMenu.this, QMacc.class);
					intent.putExtra("search_mode", KeySet.SearchMode.DAY);		
					intent.putExtra("search_group", QMacc.GroupMode.TOP1);	
					startActivity(intent);
					break;
				}	
				
				case R.id.btn_clockx:
				{
					Tclock();
					break;
				}
				case R.id.btn_exit:
				{
					new AlertDialog.Builder(MainMenu.this).setTitle(getString(R.string.str_msg)).setMessage(getString(R.string.msg_exit)).setPositiveButton(getString(R.string.str_ok), new DialogInterface.OnClickListener() {
			            public void onClick(DialogInterface dialog, int which) {
			              finish();
			            }
			          }).setNegativeButton(getString(R.string.str_cancel), new DialogInterface.OnClickListener() {
			            public void onClick(DialogInterface dialog, int which) {
			            }
			          }).show();
					break;
				}
				case R.id.layout_insert: // P⵲b
				{
					
					Intent  intent = new Intent();					
					intent.putExtra("search_mode",KeySet.SearchMode.ACTION);
					//`q~StockManage,ݫw"search_dept"@wnw
					intent.putExtra("search_dept","SOS");  //ťժܥ,@pl]p

					if (!Utilis.getIni(MainMenu.this,"SYS","DEPT",1).equalsIgnoreCase(Utilis.getIni(MainMenu.this,"SYS","DEPT",6))){
						intent.putExtra("QPosff",PItemKind.TR31);//Pf
					}else {
						intent.putExtra("QPosff",PItemKind.TR30);//`Pf
					}
					intent.setClass(MainMenu.this, QPosff.class);
					startActivity(intent);
					
					break;
				}
				case R.id.layout_psetting: // Param==>έpR
				{
					Intent  intent = new Intent();
					intent.setClass(MainMenu.this, AnslyManage.class);
					startActivity(intent);

					break;
				}
				case R.id.layout_csetting: // NX]w==>ws޲z
				{
					Intent  intent = new Intent();
					intent.setClass(MainMenu.this, StockManage.class);
					startActivity(intent);
					break;
				}
				case R.id.layout_manage: // ƺ޲z
				{
					Intent  intent = new Intent();
					intent.setClass(MainMenu.this, DataManage.class);
					startActivity(intent);
					break;
				}
				case R.id.layout_transfer: // ǰe
				{
					Intent  intent = new Intent();
					intent.setClass(MainMenu.this, TransManage.class);
					startActivity(intent);
					break;
				}
				case R.id.layout_maintain: // tκ@
				{
					Intent  intent = new Intent();
					intent.setClass(MainMenu.this, MainTainManage.class);
					startActivity(intent);
					break;
				}
				case R.id.btn_tool:
				{
					Utilis.runVibrate(MainMenu.this);

					AlertDialog.Builder sortDlg = new AlertDialog.Builder(MainMenu.this);

			        sortDlg.setTitle(getString(R.string.dlg_backup_tool))
			        .setSingleChoiceItems(R.array.select_tool, mDatabaseChoice, new DialogInterface.OnClickListener() {
			            public void onClick(DialogInterface dialog, int item) {
			            	mDatabaseChoice = item;
			            }
			        })
			        .setPositiveButton(getString(R.string.str_ok), new DialogInterface.OnClickListener() {
			            public void onClick(DialogInterface dialog, int which) {
			            	switch(mDatabaseChoice){
				            	case 0: // ƥDnƮw!
				            	{
				        			String DBZipPath=Utilis.copyDBtoSDCard(MainMenu.this);
				        			
				    				if (DBZipPath.length()>0){
				    					
					    			    Uri U=Uri.parse("file://"+DBZipPath);  //nd
				    					Intent send = new Intent(Intent.ACTION_SEND);
				    					send.setType("image/jpeg");
				    				    String uriText = "https://www.google.com/cloudprint/addpublicprinter.html?printerid=bb160853-6274-0f65-eb1f-34ae2c9ed6e1&key=19901109";
				    				    send.putExtra(Intent.ACTION_SENDTO,uriText);
				    				    send.putExtra(Intent.EXTRA_STREAM,U);
				    				    startActivity(Intent.createChooser(send, uriText));
				    				    
				    				}				    	    		    
				            		break;
				            	}
				            	
				            	case 1://
				            	{
				          		  try{
				        		      Intent goToMarket = null;
				        		      goToMarket = new Intent(Intent.ACTION_VIEW, Uri.parse("http://www.cwbuyer.net/3G006_20123/index.php"));
				        		      startActivity(goToMarket);
				        		  }catch(Exception e){
				        			  e.printStackTrace();
				        		  }
				            		break;
				            	}
				            	case 2://TRY AGAIN
				            	{
				            		gotoMT();				            		
			        		    	break;
				            	}
				            	case 3:
				            	{
					    			SQLiteDatabase db = Utilis.getDB(MainMenu.this);
					    			db.setVersion(22);
			        				Toast.makeText(MainMenu.this, "ثeƮwO : "+db.getVersion(), Toast.LENGTH_SHORT).show();        				
					    			db.close();
				            		break;
				            	}
				            	case 4:
				            	{
				            		break;
				            	}
			            	}
			            }
			          })
			        .setNegativeButton(getString(R.string.str_cancel), new DialogInterface.OnClickListener() {
			            public void onClick(DialogInterface dialog, int which) {
			            }
			          }).show();
					
				
					break;
				}
				default:
					break;
			}
		}
}
	
	@Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
          new AlertDialog.Builder(MainMenu.this).setTitle(getString(R.string.str_msg)).setMessage(getString(R.string.msg_exit)).setPositiveButton(getString(R.string.str_ok), new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
              finish();
            }
          }).setNegativeButton(getString(R.string.str_cancel), new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
            }
          }).show();
          return true;
        } else {
          return super.onKeyDown(keyCode, event);
        }
    }
	
	
	private void gotoMT(){
		LayoutInflater factory = LayoutInflater.from(MainMenu.this);
	    final View v1 = factory.inflate(R.layout.exinput, null);
	    final TextView txtReg = (TextView) v1.findViewById(R.id.TextView01);
	    final EditText edtReg = (EditText) v1.findViewById(R.id.edtReg);
	    final TextView txtWho = (TextView) v1.findViewById(R.id.TextView02);
	    final EditText edtWho = (EditText) v1.findViewById(R.id.edPswd);
	    edtReg.setText("");edtWho.setText("");
	    txtReg.setText("KX:");txtWho.setText("U");

		  new AlertDialog.Builder(MainMenu.this).setTitle("u{vtκ@").setMessage("пJKXέsU").setView(v1).setPositiveButton("OK", new DialogInterface.OnClickListener() {
              public void onClick(DialogInterface dialog, int which) {
            	  if (edtReg.getText().toString().equalsIgnoreCase(DateUtil.getSystemTime().substring(2,11)+"999") && edtWho.getText().toString().indexOf("/")>0){
            	        int isError=AppUtil.initPref_err(MainMenu.this,mac,edtWho.getText().toString(),1);
            	  }              
              }
		  }).setCancelable(false).show();
	}

	
	int Stat=-1;
	String aEmpID="";
	String aEmpName="";
	String theD="";
	String Ttime="";
	String TSec="";
	int work;
	String SQL="";	
	String goD="12:00";//ӤHWZɶȯZ
	String outD="24:00";//UZ
	int sala=120;
	int radio=0;
	String [] args={"",""};
	String theT="";
	int Wday=1;
	StringBuffer bfstr = new StringBuffer();
	StringBuffer bfstrF = new StringBuffer();
	
	//String [] wekD={"","@","G","T","|","",""};
	//String defD="¾Z";

	private void Tclock(){
		
 		LayoutInflater factory = LayoutInflater.from(MainMenu.this);
		final View v1 = factory.inflate(R.layout.fclock, null);
		DisplayMetrics dm = new DisplayMetrics();
        getWindowManager().getDefaultDisplay().getMetrics(dm);
        int Wwidth = dm.widthPixels;
        int Wheight = dm.heightPixels;
		Stat=-1;
		  theD=Utilis.getCurrentDate();  //2012-10-22
			Ttime=DateUtil.getSystemTime().substring(8, 10);  //oثeXI
			TSec=DateUtil.getSystemTime().substring(10, 12);  //oثeX
				if (Utilis.toInt(Ttime)<=5)  theD = Utilis.addDate(theD, -1);
				theD = theD.replace("/", "-");
				if (Utilis.getIni(this,"SYS", "DEV", 7)!=null  && Utilis.getIni(this,"SYS", "DEV", 7).length()>0) goD=Utilis.getIni(this,"SYS", "DEV", 7);
				if (Utilis.getIni(this,"SYS", "DEV", 8)!=null  && Utilis.getIni(this,"SYS", "DEV", 8).length()>0) outD=Utilis.getIni(this,"SYS", "DEV", 8);
		
		((LinearLayout) v1.findViewById(R.id.layout_top)).getLayoutParams().height=(int )Wheight/6;
		((TextView) v1.findViewById(R.id.text_vdate)).setText(theD);
		final EditText editText = (EditText) v1.findViewById(R.id.text_who);
		if (Utilis.toInt(Ttime)>=15) {
			((RadioButton) v1.findViewById(R.id.radio1)).setChecked(true);
		}else{
			((RadioButton) v1.findViewById(R.id.radio0)).setChecked(true);
		}

		editText.setOnEditorActionListener(new OnEditorActionListener() {  
			@Override  
			public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {  
    			//JN(ENTER),ˬdO_sb
				if (editText.getText().toString().length()>0){
					String Chk=editText.getText().toString().trim();
					if (Chk.indexOf("/")==0) Chk=Chk.substring(1);
	    			SQL="select distinct CUSTNO,CUSTNAME,MSN from qcust where CUSTNO='"+Chk+"' and TR='40' limit 1";
					
					if  (Utilis.haveInternet(MainMenu.this) && Utilis.toInt(Utilis.getIni(MainMenu.this, "SYS", "IMPORT", 3))==1){
						bfstr.delete(0, bfstr.toString().length());
						bfstrF.delete(0, bfstrF.toString().length());
						bfstr.append(Utilis.getIni(MainMenu.this, "SYS", "IMPORT", 2)).append(";");
						bfstrF.append("UID").append(";");
						bfstr.append(SQL);
						bfstrF.append("SQLADD");
						work=0;cloudClock( bfstr, bfstrF);
					}
		    			SQLiteDatabase db = Utilis.getDB(MainMenu.this);
		    			Cursor cs=db.rawQuery(SQL, null);
		    			if (cs.getCount()>0){
		    				cs.moveToFirst();
		    				((TextView) v1.findViewById(R.id.text_whoname)).setText(cs.getString(1));
		    				aEmpID=cs.getString(0);
		    				aEmpName=cs.getString(1);
		    				//Toast.makeText(MainMenu.this, "Who ="+cs.getString(0)+"/"+cs.getString(1), Toast.LENGTH_SHORT).show();
		    				//d,n
		    				if (cs.getInt(2)>=0 && cs.getInt(2)<=9)  Stat=cs.getInt(2); else Stat=0;
		    			}else{
		    				Stat=-1;	aEmpID="";	aEmpName="";
		    			}
		    			db.close();
		    			cs.close();
		    			
	    			if (Stat<0)	Toast.makeText(MainMenu.this, "dLd,Lkd!!"+Chk+"___loca="+Chk.indexOf("/"), Toast.LENGTH_SHORT).show();
	    			
					((TextView) v1.findViewById(R.id.text_who)).setText(aEmpID);
					((TextView) v1.findViewById(R.id.text_whoname)).setText(aEmpName);					
					
   				 	if (((RadioButton) v1.findViewById(R.id.radio2)).isChecked() && Stat>=0){
   						Intent  intent = new Intent();					
   						intent.putExtra("WHO",aEmpID);
   						intent.putExtra("WHONAME",aEmpName);
   						intent.setClass(MainMenu.this, QRep_05.class);
   						startActivity(intent);
   				 		//showClockrep();
   				 	}
   				 	  
   				 	 
				}
    			return false;  
			}
		});
		  new AlertDialog.Builder(MainMenu.this).setTitle("[X][WUZ][d]"+Wwidth+"_"+Wheight).setView(v1).setNeutralButton("d", new DialogInterface.OnClickListener() {
		      public void onClick(DialogInterface dialog, int which) {
		    	  //Fd,˹O_ӭ,öiJƮwˬdO_ƥd
		    	  if (Stat>=0){//ܦH
		    		  Calendar calendar = Calendar.getInstance();
		    		  //w,XOPX
		    		  calendar.set(Calendar.YEAR, Integer.valueOf(theD.substring(0, 4)));
		    		  calendar.set(Calendar.MONTH, Integer.valueOf(theD.substring(5, 7))-1);
		    		  calendar.set(Calendar.DATE, Integer.valueOf(theD.substring(8, 10)));
		    		  //Ӧb,ܦ
		    		  Wday = calendar.get(Calendar.DAY_OF_WEEK);
		    		  Ttime=DateUtil.getSystemTime().substring(8, 10);  //oثeXI
		    		  TSec=DateUtil.getSystemTime().substring(10, 12);  //oثeX

		    		  //oԪ骺WUZɨ
		    		  SQL="select * from qemp where QEMPID='"+Stat+"' and MOBIL='"+Wday+"' and STATE='R'";
		    		  if (((RadioButton) v1.findViewById(R.id.radio0)).isChecked())
		    			  radio=0;  else  if (((RadioButton) v1.findViewById(R.id.radio1)).isChecked())
		    				  radio=1; else radio=2;
		    		  
						if  (Utilis.haveInternet(MainMenu.this) && Utilis.toInt(Utilis.getIni(MainMenu.this, "SYS", "IMPORT", 3))==1){
							
							bfstr.delete(0, bfstr.toString().length());
							bfstrF.delete(0, bfstrF.toString().length());
							
							bfstr.append(Utilis.getIni(MainMenu.this, "SYS", "IMPORT", 2)).append(";");
							bfstrF.append("UID").append(";");
							bfstr.append(aEmpID).append(";");
							bfstrF.append("EMPID").append(";");
							bfstr.append(aEmpName).append(";");
							bfstrF.append("EMPNAME").append(";");
							bfstr.append(Utilis.getIni(MainMenu.this,"SYS","DEPT",1)).append(";");
							bfstrF.append("DEPTNO").append(";");
							bfstr.append(""+radio).append(";");
							bfstrF.append("RADIO").append(";");
							bfstr.append(theD).append(";");
							bfstrF.append("TDAY").append(";");
							bfstr.append(Ttime+":"+TSec).append(";");
							bfstrF.append("TTIME").append(";");
							bfstr.append(Wday).append(";");
							bfstrF.append("WDAY").append(";");
							bfstr.append(Stat).append(";");
							bfstrF.append("SATA").append(";");
							bfstr.append(DateUtil.getSystemTime().substring(3,14)).append(";");
							bfstrF.append("WHATIME").append(";");
							bfstr.append(SQL);
							bfstrF.append("SQLADD");
							work=1;cloudClock( bfstr, bfstrF);
						}
						//AnsJ ٭nLOCALݦsJ
				    		  SQLiteDatabase db = Utilis.getDB(MainMenu.this);
				    		  Cursor cs=db.rawQuery(SQL, null);
				    		  //12@3G......7
				    		  //oȶԪ(STATE='R') TZOgXWUZɶ,æsJ
				    		  if (cs.getCount()>0){
				    			  cs.moveToFirst();
				    			  goD=cs.getString(cs.getColumnIndex("GMAIL"));
				    			  outD=cs.getString(cs.getColumnIndex("PS"));
				    			  sala=cs.getInt(cs.getColumnIndex("GPSLA"));
				    		  }
						
				    		  SQL="select * from qemp where QEMPID='"+aEmpID+"' and MOBIL='"+theD+"'";
				    		  cs=db.rawQuery(SQL, null);
							  ContentValues value = new ContentValues();
				    		  if (cs.getCount()>0){//iOĤGqem@~,wإߥd򥻸
				    			  cs.moveToFirst();
				    			  theT=cs.getString(cs.getColumnIndex("EMAIL"));//WZɤ
				    			  if (radio==0){
				    				  if (theT !=null && theT.length()>0){
					  	    				Toast.makeText(MainMenu.this, "wLd!!iƳ!!", Toast.LENGTH_SHORT).show();
				    				  }else{//iHd
				    					  value.put("MOBIL", theD);
				    					  value.put("EMAIL", Ttime+":"+TSec);//:
				    					  value.put("STATE", "0");
				    					  value.put("PIC", goD);
				    					  value.put("BIRTHDAY", outD);
				    					  value.put("PS", ""+Wday);
				    					  value.put("CREATEDATETIME", DateUtil.getSystemTime().substring(3,14));
				    					  args[0]=aEmpID;	args[1]=theD;
				    					  db.update("qhead", value, "QEMPID=? and MOBIL=? ", args);
				    					  
					  	    				Toast.makeText(MainMenu.this, "d:"+theD+"ɶ:"+Ttime+":"+TSec+" \!!", Toast.LENGTH_SHORT).show();
				    					  
				    				  }
				    			  }else{//ˬdUZ
				    				  theT=cs.getString(cs.getColumnIndex("GMAIL"));
				    				  if (theT !=null && theT.length()>0){
				  	    				Toast.makeText(MainMenu.this, "wLd!!iƳ!!", Toast.LENGTH_SHORT).show();
				    				  }else{//iHsJ
				    					  value.put("MSN", theD);
				    					  value.put("GMAIL", Ttime+":"+TSec);//:
				    					  value.put("STATE", "1");
				    					  value.put("PIC", goD);
				    					  value.put("BIRTHDAY", outD);
				    					  value.put("PS", ""+Wday);
				    					  value.put("CREATEDATETIME", DateUtil.getSystemTime().substring(3,14));
				    					  args[0]=aEmpID;	args[1]=theD;
				    					  db.update("qemp", value, "QEMPID=? and MOBIL=? ", args);
				    					  
					  	    				Toast.makeText(MainMenu.this, "d:"+theD+"ɶ:"+Ttime+":"+TSec+" \!!", Toast.LENGTH_SHORT).show();
				    					  
				    				  }
				    			  }
				    		  }else{//qsJ INSERT
		    					  if (radio==0)
		    						  value.put("EMAIL", Ttime+":"+TSec);//:
		    					  else
		    						  value.put("GMAIL", Ttime+":"+TSec);//:
		    					  
				    			  value.put("QEMPID", aEmpID);
		    					  value.put("QEMPNAME", aEmpName);
		    					  value.put("MOBIL", theD);
		    					  value.put("GPSLA", sala);
		    					  value.put("DEPTNO", Utilis.getIni(MainMenu.this,"SYS","DEPT",1));
		    					  value.put("STATE", ""+radio);
		    					  value.put("PIC", goD);
		    					  value.put("BIRTHDAY", outD);
		    					  value.put("ADDRESS", ""+Stat);
		    					  value.put("PS", ""+Wday);
		    					  value.put("CREATEDATETIME", DateUtil.getSystemTime().substring(3,14));
		    					  db.insert("qemp", null, value);
		  	    				Toast.makeText(MainMenu.this, "d:"+theD+"ɶ:"+Ttime+":"+TSec+" \!!", Toast.LENGTH_SHORT).show();
				    		  }
				    		  cs.close();
				    		  db.close();
						
		    	  }else{
	    				Toast.makeText(MainMenu.this, "d!!"+editText.getText().toString().trim(), Toast.LENGTH_SHORT).show();
		    	  }
		      }
		    }).setNegativeButton("", new DialogInterface.OnClickListener() {
			      public void onClick(DialogInterface dialog, int which) {
			    	 //󥴥d
	   				 	if (((RadioButton) v1.findViewById(R.id.radio2)).isChecked()){
	 						Intent  intent = new Intent();					
	 						intent.putExtra("WHO",aEmpID);
	 						intent.putExtra("WHONAME",aEmpName);
	 						intent.setClass(MainMenu.this, QRep_05.class);
	 						startActivity(intent);
	   				 	}
			      }
		    })
		    .show();
	}
	
	private void cloudClock(StringBuffer bfstr,StringBuffer bfstrF){
		final String []fields=bfstr.toString().split(";");
		final String []fieldFs=bfstrF.toString().split(";");
	      myDialog = ProgressDialog.show(MainMenu.this,"ƳBz.....","еy.............",true);			  
		  
	      new Thread()
	      { 
	        public void run()
	        { 
	          try
	          {
	        	  String uriH="http://"+Utilis.getIni(MainMenu.this, "SYS", "IMPORT", 1)+File.separator+Utilis.getIni(MainMenu.this, "SYS", "IMPORT", 2)+File.separator;
	        	  switch (work){
        	  		case 0:
    					uriAPI=uriH+"qrepclock00.php";
        	  			break;
        	  		case 1:
        	  			uriAPI=uriH+"qrepclock01.php";
        	  			break;
	        	  }
					HttpPost httpRequest = new HttpPost(uriAPI);
					List<NameValuePair> params = new ArrayList<NameValuePair>();
					for(int x=0;x<fields.length;x++){
						params.add(new BasicNameValuePair(fieldFs[x], fields[x]));
					}
					try {
						httpRequest.setEntity(new UrlEncodedFormEntity(params, HTTP.UTF_8));
						HttpResponse httpResponse = new DefaultHttpClient()
								.execute(httpRequest);
						if (httpResponse.getStatusLine().getStatusCode() == 200)
						{
							String strResult = EntityUtils.toString(httpResponse	.getEntity());
							mHandlerQRC_00.obtainMessage(REFRESH_DATA, strResult).sendToTarget();
						}
					} catch (Exception e)
					{
						e.printStackTrace();
					}
	          }
	          catch (Exception e)
	          {
	            e.printStackTrace();
	          }
	          finally
	          {
	            // ҫإߪmyDialogC
	            myDialog.dismiss();
	          }
	        }
	      }.start(); 

	}
	
  	Handler mHandlerQRC_00 = new Handler()
	{//تO o dd N W MSN='0123456789'ZO
		@Override
		public  void handleMessage(Message msg)
		{
			String Hresult=null;
			switch (msg.what)
			{
			case REFRESH_DATA:
				if (msg.obj instanceof String) 
					Hresult = (String) msg.obj;
				if (Hresult != null ){
					//Log.i("DOWNLOAD_6_mHandler_QEMP_CLOCK__00===", ""+Hresult);
					switch (work){
						case 0:
							if (Hresult.indexOf("SSSS\r\n")>2){
									String Lines[] =Hresult.split(";");
									aEmpID=Lines[1];
									aEmpName=Lines[2];
									if (Lines[3] !=null && Lines[3].length()>0)
										if (Utilis.toInt(Lines[3])<=9) Stat=Utilis.toInt(Lines[3]); else Stat=0; else Stat=0;
							}else{
			    				Stat=-1;	aEmpID="";	aEmpName="";
							}
							break;
						case 1:
							String mssg=aEmpID+"/"+aEmpName;
							if (Hresult.indexOf("insert_success_0")>=0){
								mssg=mssg+"WZd\!!";
							}else if (Hresult.indexOf("insert_success_1")>=0){
								mssg=mssg+"UZd\!!";
							}else if (Hresult.indexOf("goD_is_update")>=0){
								mssg=mssg+"WZɥd\!!nѤFWZd!!";
							}else if (Hresult.indexOf("outD_is_update")>=0){
								mssg=mssg+"UZd\";
							}else if (Hresult.indexOf("goD_is_update_fail")>=0){
								mssg=mssg+"WZd,Эsd!!";
							}else if (Hresult.indexOf("outD_is_update_fail")>=0){
								mssg=mssg+"UZd,Эsd!!";
							}else if (Hresult.indexOf("goD_is_already")>=0){
								mssg=mssg+"WZwd,iHƥd!!";
							}else if (Hresult.indexOf("outD_is_already")>=0){
								mssg=mssg+"UZwd,iHƥd!!";
							}
							Toast.makeText(MainMenu.this, mssg, Toast.LENGTH_SHORT).show();
							break;
					}
				}
			}
		}
	};
	
	  private 	void mupdate_qc(String gUid,String Id,String UPD){
			StringBuffer bfstr = new StringBuffer();
			StringBuffer bfstrF = new StringBuffer();
				bfstr.append(gUid).append(";");
				bfstrF.append("UID").append(";");
				bfstr.append(Id).append(";");
				bfstrF.append("ID").append(";");
				bfstr.append(UPD);
				bfstrF.append("LUPDATE");
			Thread t = new Thread(new DBCloud.sendPostRunnable(this,bfstr.toString(),bfstrF.toString(),uriAPI,1));
			t.start();
}

	
	
	/**
	 *  Menu ϥ
	 */
}
