package com.cwbuyer.main;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.AdapterView.OnItemLongClickListener;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.cwbuyer.lib.DataImports;
import com.cwbuyer.lib.QRep_08;
import com.cwbuyer.lib.SysSetup;
import com.cwbuyer.lib.Utilis;
import com.pwbuyer.main.R;

// 上傳下載
public class TransManage  extends Activity {

	final String myImportPath =android.os.Environment.getExternalStorageDirectory().getAbsolutePath()+Utilis.getIni(this, "SYS", "YEAR",7);
	
	public ProgressDialog myDialog = null;
	
	private int PSWD=Utilis.toInt(Utilis.getIni(this,"SYS","DEPT",5)); //0OK 1密碼不符
	
    private final int RESULT_QCUSTFF = 9999;
	private int nPart=0; //預設0總店  1分店
	private int nAA=0;
	private String[] mNames=new String[]{"以批號匯入新品","上傳下載設定","刪單改單異樣報告","返回"};
	Bundle bundle;	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.manage_layout);
//		ParamAdapter adapter = new ParamAdapter(this);
		nAA=Utilis.toInt(Utilis.getIni(TransManage.this,"SYS","DATA_SEND",8));
		if (!Utilis.getIni(TransManage.this,"SYS","DEPT",1).equalsIgnoreCase(Utilis.getIni(TransManage.this,"SYS","DEPT",6)))
			nPart=1;  //1.門市版 0.總店

		DataAdapter adapter = new DataAdapter(this);
		ListView listview = (ListView)findViewById(R.id.listview);
		listview.setAdapter(adapter);
		listview.setOnItemClickListener(new OnItemClickListener(){
			@Override
			public void onItemClick(AdapterView<?> adapter, View view, int pos,
			long arg3) {
				Utilis.runVibrate(TransManage.this);
				Intent intent = new Intent();
//"結帳匯出","匯入(總倉出貨)","匯入(各店庫存)","上傳下載設定"				
//	"以批號匯入新品","出貨匯給總店","匯入總店交易","出貨匯給門市","匯入門市結帳","總倉門市庫存匯出","上傳下載設定"
//	"以批號匯入新品","結帳匯給總倉","匯入總倉到貨","出貨匯給門市","匯入門市結帳","總倉門市庫存匯出","上傳下載設定"
				switch(pos){
					case 0: { 
							intent.setClass(TransManage.this, DataImports.class);
							intent.putExtra("make_mode",0);  //0原始功能 匯入新品  
							startActivity(intent);					
						break;				
					}
					case 1: { 
						if (nPart==0 && PSWD!=1 ) { //上傳下載設定
							intent.setClass(TransManage.this, SysSetup.class);
							startActivity(intent);
						}
						break;				
					}
					case 2:{
						intent.setClass(TransManage.this, QRep_08.class);
						startActivity(intent);
						break;	
					}
					case 3:
						finish();
						break;
				} //end_switch
			}
		});
		
		((Button)findViewById(R.id.btn_exit)).setOnClickListener(new MainClick());
		
		//碰到須重傳的ZIP檔,可以列出清單為 1.已傳送的功能
		listview.setOnItemLongClickListener(new OnItemLongClickListener(){

			@Override
			public boolean onItemLongClick(AdapterView<?> arg0, View arg1,
					int arg2, long arg3) {
				// TODO Auto-generated method stub
				Utilis.runVibrate(TransManage.this);
				Intent intent = new Intent();
				
				switch (arg2){
					case 0:
						Toast.makeText(TransManage.this, "功能保留!!", Toast.LENGTH_SHORT).show();
						break;	
					case 1:
					{
					      myDialog = ProgressDialog.show(TransManage.this,"資料處理中.....","請稍候.............",true);//		setAutoRotationMode();			  
					      new Thread()
					      { 
					        public void run()
					        { 
					          try
					          { 
									SQLiteDatabase db = Utilis.getDB(TransManage.this);
									String roots=android.os.Environment.getExternalStorageDirectory().getAbsolutePath()+"/CWBuyer/";
									if (roots.equalsIgnoreCase("/mnt/sdcard/0/CWBuyer/")){
										//本機可能為Sumsung
										db.execSQL("update qdetail set PIC=replace(PIC,'/mnt/sdcard/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/CWBuyer/%'");
										db.execSQL("update qitems set PIC=replace(PIC,'/mnt/sdcard/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/CWBuyer/%'");
										db.execSQL("update qdetail set PICTURE=replace(PICTURE,'/mnt/sdcard/CWBuyer/','"+roots+"') where PICTURE like '%/mnt/sdcard/CWBuyer/%'");
										db.execSQL("update qcust set PIC=replace(PIC,'/mnt/sdcard/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/CWBuyer/%'");
										db.execSQL("update qfact set PIC=replace(PIC,'/mnt/sdcard/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/CWBuyer/%'");
										db.execSQL("update qc_type set PIC=replace(PIC,'/mnt/sdcard/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/CWBuyer/%'");
										db.execSQL("update qmacc set PIC=replace(PIC,'/mnt/sdcard/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/CWBuyer/%'");
										db.execSQL("update qc_macc set PIC=replace(PIC,'/mnt/sdcard/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/CWBuyer/%'");
										
										db.execSQL("update qdetail set PIC=replace(PIC,'/storage/emulated/0/cwbuyer/','"+roots+"') where PIC like '%/storage/emulated/0/cwbuyer/%'");
										db.execSQL("update qitems set PIC=replace(PIC,'/storage/emulated/0/cwbuyer/','"+roots+"') where PIC like '%/storage/emulated/0/cwbuyer/%'");
										db.execSQL("update qdetail set PICTURE=replace(PICTURE,'/storage/emulated/0/cwbuyer/','"+roots+"') where PICTURE like '%/storage/emulated/0/cwbuyer/%'");
										db.execSQL("update qcust set PIC=replace(PIC,'/storage/emulated/0/cwbuyer/','"+roots+"') where PIC like '%/storage/emulated/0/cwbuyer/%'");
										db.execSQL("update qfact set PIC=replace(PIC,'/storage/emulated/0/cwbuyer/','"+roots+"') where PIC like '%/storage/emulated/0/cwbuyer/%'");
										db.execSQL("update qc_type set PIC=replace(PIC,'/storage/emulated/0/cwbuyer/','"+roots+"') where PIC like '%/storage/emulated/0/cwbuyer/%'");
										db.execSQL("update qmacc set PIC=replace(PIC,'/storage/emulated/0/cwbuyer/','"+roots+"') where PIC like '%/storage/emulated/0/cwbuyer/%'");
										db.execSQL("update qc_macc set PIC=replace(PIC,'/storage/emulated/0/cwbuyer/','"+roots+"') where PIC like '%/storage/emulated/0/cwbuyer/%'");
									}else if (roots.equalsIgnoreCase("/mnt/sdcard/CWBuyer/")){
										db.execSQL("update qdetail set PIC=replace(PIC,'/mnt/sdcard/0/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/0/CWBuyer/%'");
										db.execSQL("update qitems set PIC=replace(PIC,'/mnt/sdcard/0/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/0/CWBuyer/%'");
										db.execSQL("update qdetail set PICTURE=replace(PICTURE,'/mnt/sdcard/0/CWBuyer/','"+roots+"') where PICTURE like '%/mnt/sdcard/0/CWBuyer/%'");
										db.execSQL("update qcust set PIC=replace(PIC,'/mnt/sdcard/0/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/0/CWBuyer/%'");
										db.execSQL("update qfact set PIC=replace(PIC,'/mnt/sdcard/0/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/0/CWBuyer/%'");
										db.execSQL("update qc_type set PIC=replace(PIC,'/mnt/sdcard/0/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/0/CWBuyer/%'");
										db.execSQL("update qmacc set PIC=replace(PIC,'/mnt/sdcard/0/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/0/CWBuyer/%'");
										db.execSQL("update qc_macc set PIC=replace(PIC,'/mnt/sdcard/0/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/0/CWBuyer/%'");
										
										db.execSQL("update qdetail set PIC=replace(PIC,'/storage/emulated/0/cwbuyer/','"+roots+"') where PIC like '%/storage/emulated/0/cwbuyer/%'");
										db.execSQL("update qitems set PIC=replace(PIC,'/storage/emulated/0/cwbuyer/','"+roots+"') where PIC like '%/storage/emulated/0/cwbuyer/%'");
										db.execSQL("update qdetail set PICTURE=replace(PICTURE,'/storage/emulated/0/cwbuyer/','"+roots+"') where PICTURE like '%/storage/emulated/0/cwbuyer/%'");
										db.execSQL("update qcust set PIC=replace(PIC,'/storage/emulated/0/cwbuyer/','"+roots+"') where PIC like '%/storage/emulated/0/cwbuyer/%'");
										db.execSQL("update qfact set PIC=replace(PIC,'/storage/emulated/0/cwbuyer/','"+roots+"') where PIC like '%/storage/emulated/0/cwbuyer/%'");
										db.execSQL("update qc_type set PIC=replace(PIC,'/storage/emulated/0/cwbuyer/','"+roots+"') where PIC like '%/storage/emulated/0/cwbuyer/%'");
										db.execSQL("update qmacc set PIC=replace(PIC,'/storage/emulated/0/cwbuyer/','"+roots+"') where PIC like '%/storage/emulated/0/cwbuyer/%'");
										db.execSQL("update qc_macc set PIC=replace(PIC,'/storage/emulated/0/cwbuyer/','"+roots+"') where PIC like '%/storage/emulated/0/cwbuyer/%'");
									}else{//storage/emulated/0/
										db.execSQL("update qdetail set PIC=replace(PIC,'/mnt/sdcard/0/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/0/CWBuyer/%'");
										db.execSQL("update qitems set PIC=replace(PIC,'/mnt/sdcard/0/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/0/CWBuyer/%'");
										db.execSQL("update qdetail set PICTURE=replace(PICTURE,'/mnt/sdcard/0/CWBuyer/','"+roots+"') where PICTURE like '%/mnt/sdcard/0/CWBuyer/%'");
										db.execSQL("update qcust set PIC=replace(PIC,'/mnt/sdcard/0/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/0/CWBuyer/%'");
										db.execSQL("update qfact set PIC=replace(PIC,'/mnt/sdcard/0/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/0/CWBuyer/%'");
										db.execSQL("update qc_type set PIC=replace(PIC,'/mnt/sdcard/0/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/0/CWBuyer/%'");
										db.execSQL("update qmacc set PIC=replace(PIC,'/mnt/sdcard/0/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/0/CWBuyer/%'");
										db.execSQL("update qc_macc set PIC=replace(PIC,'/mnt/sdcard/0/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/0/CWBuyer/%'");
										
										db.execSQL("update qdetail set PIC=replace(PIC,'/mnt/sdcard/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/CWBuyer/%'");
										db.execSQL("update qitems set PIC=replace(PIC,'/mnt/sdcard/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/CWBuyer/%'");
										db.execSQL("update qdetail set PICTURE=replace(PICTURE,'/mnt/sdcard/CWBuyer/','"+roots+"') where PICTURE like '%/mnt/sdcard/CWBuyer/%'");
										db.execSQL("update qcust set PIC=replace(PIC,'/mnt/sdcard/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/CWBuyer/%'");
										db.execSQL("update qfact set PIC=replace(PIC,'/mnt/sdcard/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/CWBuyer/%'");
										db.execSQL("update qc_type set PIC=replace(PIC,'/mnt/sdcard/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/CWBuyer/%'");
										db.execSQL("update qmacc set PIC=replace(PIC,'/mnt/sdcard/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/CWBuyer/%'");
										db.execSQL("update qc_macc set PIC=replace(PIC,'/mnt/sdcard/CWBuyer/','"+roots+"') where PIC like '%/mnt/sdcard/CWBuyer/%'");
										
									}
									db.close();
									Toast.makeText(TransManage.this, "所有圖檔已更新路徑成功!!", Toast.LENGTH_SHORT).show();
					          }
					          catch (Exception e)
					          {
					            e.printStackTrace();
					          }
					          finally
					          {
					            // 卸載所建立的myDialog物件。
					            myDialog.dismiss();
					          }
					        }
					      }.start(); /* 開始執行執行緒 */
					break;	
					}
				}
				
				return true;
			}
			
		});
	}  //END 主程式

//範例:帶回QCUSTFF中找到的客戶資料(CUSTNO,TR)
//需搭配臨時的[密碼設定]及本段的回應OK時,取得	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		// TODO Auto-generated method stub
		super.onActivityResult(requestCode, resultCode, data);
		String SS,SK;
		if(requestCode == RESULT_QCUSTFF){
			if (resultCode == RESULT_OK) {
//				String ECHOS = data.getDataString("acust_key");
				SS=data.getStringExtra("acust_key");
				SK=data.getStringExtra("acust_kind");
    			Toast.makeText(TransManage.this, "回傳訊息="+SS+"資料TR="+SK, Toast.LENGTH_SHORT).show();
			}
		}
	}
	
	// 顯示匯入新品資料的Dialog//path 就是實際的檔案全名,只等開啟
	
	
	class DataAdapter extends BaseAdapter{
		
		private LayoutInflater mInflater;
		
		public DataAdapter(Context context) {
		      /* 參數初始化 */
		      mInflater = LayoutInflater.from(context);
		}
		
		public int getCount() {
			return mNames.length;
		}

		public Object getItem(int position) {
			return position;
		}

		public long getItemId(int position) {
			return position;
		}

		public View getView(int position, View convertView, ViewGroup parent) {
			ViewHolder holder;
			if (convertView == null) {
				convertView = mInflater.inflate(R.layout.list_param, null);
				holder = new ViewHolder();
				holder.textName = (TextView) convertView
						.findViewById(R.id.text_title);
				convertView.setTag(holder);
			} else {
				holder = (ViewHolder) convertView.getTag();
			}
			holder.textName.setText(mNames[position]);
			return convertView;
		}

		/* class ViewHolder */
		private class ViewHolder {
			TextView textName;
		}
	}
	
	class MainClick implements OnClickListener {
		@Override
		public void onClick(View v) {
			Utilis.runVibrate(TransManage.this);
			int id = v.getId();
			switch (id) {
				case R.id.btn_exit:
				{
					finish();
					break;
				}
			}
		}
	}
}
