package com.cwbuyer.lib;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileDescriptor;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Set;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;

import com.pwbuyer.main.R;
import com.cwbuyer.format.IDialog;
import com.cwbuyer.format.ItemData;
import com.cwbuyer.main.AItem;
import com.cwbuyer.main.MainMenu;
import com.cwbuyer.main.APos.PItemKind;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.ActivityNotFoundException;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.res.TypedArray;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.Bitmap;
import android.graphics.Bitmap.CompressFormat;
import android.graphics.Bitmap.Config;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.LinearGradient;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.PorterDuff.Mode;
import android.graphics.PorterDuffXfermode;
import android.graphics.Shader.TileMode;
import android.media.ExifInterface;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.os.ParcelFileDescriptor;
import android.provider.MediaStore;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.animation.AlphaAnimation;
import android.view.animation.AnimationSet;
import android.view.animation.TranslateAnimation;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.Gallery;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemLongClickListener;

public class GalleryViewPic extends Activity {

	private Gallery mGallery01;
	private ImageView mImage;
	private TextView mTextView01;
	private TextView mTextView02;
	private TextView mTextView03;
	private TextView mTextView04;
	private TextView mTextView05;
	
//  	private LinearLayout lTableView = null;
	String SAVE_FOLDER = Environment.getExternalStorageDirectory().getAbsolutePath() + File.separator+"DCIM/CWBuyer" ;
	String filepath=android.os.Environment.getExternalStorageDirectory().getAbsolutePath()+ File.separator + "DCIM/CWBuyer"  ;
	String uriAPI=null;
	Bitmap mBitmap=null;
	private int rotationInDegrees=0;
	private final int TPICTURE = 1009;
	private final int SELECT_PICTURE = 1010;
	private String mImagePath = null;
	private static int nPicDegree =0;
	Uri mImageCaptureUri = null;

	public ItemData iData;	

	private ArrayList<String> mCountryList = new ArrayList<String>();
	private ArrayList<Integer> mCountryIdList = new ArrayList<Integer>();
	private ArrayList<String> mTypeList = new ArrayList<String>();
	private ArrayList<Integer> mTypeIdList = new ArrayList<Integer>();
	
	HashMap<Integer,Integer> mCountRow = new HashMap<Integer,Integer>(); // C
	HashMap<Integer,String> mCountCell = new HashMap<Integer,String>();  // 

	int maxRec = 20;
	int positions = 0;
	private Bitmap reflactionBitmap; //ѵe
	//int PSWD=Utilis.toInt(Utilis.getIni(this,"SYS","DEPT",5));
	private String [] DialogMenu={"s-Ӭ","s-ۥ","","^"};	
	
	String[] menu_X={"l","^" };
	String[] menu_Y={"SʹL","wʹL" };
	
	String goodsPic = "";
	private String batch=null;
	private String goods=null;
	private String[] Apicstr; //ɦW
	private int[] StyleSrc;
	int Wheight;
	int Wwidth;
	Bundle bundle;
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		// TODO Auto-generated method stub
		super.onActivityResult(requestCode, resultCode, data);
		String OutPhotoURI="";
		if ((requestCode == SELECT_PICTURE) && (resultCode == RESULT_OK)) // ۥ
		{
			//Uri uri = data.getData();
            Uri selectedImageUri = data.getData();
	            if (StyleSrc[positions]==0){//ADD
	        		File folder = new File(SAVE_FOLDER);
	        		if (folder.exists() == false) folder.mkdirs();
	            	mImagePath=filepath+goods+"_"+ String.valueOf(DateUtil.getSystemTime()).substring(12)+ ".jpg";
	            	Apicstr[positions]=mImagePath;
	            	StyleSrc[positions]=1;
	            }else{//EDIT ϥέӪɦW
	            	mImagePath=Apicstr[positions];
	            	StyleSrc[positions]=1;
	            }
            
            Bitmap bitmap=null;
//        	Toast.makeText(this, "\"+Build.VERSION.SDK_INT, Toast.LENGTH_SHORT).show();
            
            if (Build.VERSION.SDK_INT < 19) {
            	OutPhotoURI = getPath(selectedImageUri);
            	mBitmap = Utilis.getScaleBitmap(OutPhotoURI, 650, 952);
                //mBitmap = BitmapFactory.decodeFile(OutPhotoURI);
//            	Toast.makeText(this, "\"+Build.VERSION.SDK_INT, Toast.LENGTH_SHORT).show();
				try {
					ExifInterface exif = new ExifInterface(OutPhotoURI);
					int rotation = exif.getAttributeInt(ExifInterface.TAG_ORIENTATION, ExifInterface.ORIENTATION_NORMAL);
					rotationInDegrees = exifToDegrees(rotation);
					Matrix matrix = new Matrix();
					matrix.preRotate(rotationInDegrees);
					bitmap = Bitmap.createBitmap(mBitmap, 0, 0, 650, 952, matrix, true);
					
    		        FileOutputStream fos = null;
    				try {
    						fos = new FileOutputStream(mImagePath);
   	    					bitmap.compress(CompressFormat.JPEG, 100, fos);
   	    					fos.close();
   	    					mBitmap=bitmap;	
    				} catch (FileNotFoundException e) {
    					// TODO Auto-generated catch block
    					e.printStackTrace();
    				}
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
            }
            else
            {
                ParcelFileDescriptor parcelFileDescriptor;
                try {
                    parcelFileDescriptor = getContentResolver().openFileDescriptor(selectedImageUri, "r");
                    FileDescriptor fileDescriptor = parcelFileDescriptor.getFileDescriptor();
                    bitmap = BitmapFactory.decodeFileDescriptor(fileDescriptor);
                    parcelFileDescriptor.close();

    				ByteArrayOutputStream stream = new ByteArrayOutputStream();
    				bitmap.compress(Bitmap.CompressFormat.JPEG, 100, stream);// (0 - 100)
    		        FileOutputStream fos = null;
    				try {
    						fos = new FileOutputStream(mImagePath);
    				} catch (FileNotFoundException e) {
    					// TODO Auto-generated catch block
    					e.printStackTrace();
    				}
    				try {
    					bitmap.compress(CompressFormat.JPEG, 100, fos);
    					fos.close();
    					mBitmap = Utilis.getScaleBitmap(mImagePath,650, 952);
    	                //mBitmap = BitmapFactory.decodeFile(OutPhotoURI);
    					
    					try {
    						ExifInterface exif = new ExifInterface(mImagePath);
    						int rotation = exif.getAttributeInt(ExifInterface.TAG_ORIENTATION, ExifInterface.ORIENTATION_NORMAL);
    						rotationInDegrees = exifToDegrees(rotation);
    						Matrix matrix = new Matrix();
    						matrix.preRotate(rotationInDegrees);
    						bitmap = Bitmap.createBitmap(mBitmap, 0, 0, 650, 952, matrix, true);

    						try {
    	    						fos = new FileOutputStream(mImagePath);
    	   	    					bitmap.compress(CompressFormat.JPEG, 100, fos);
    	   	    					fos.close();
    	   	    					mBitmap=bitmap;	
    	    				} catch (FileNotFoundException e) {
    	    					// TODO Auto-generated catch block
    	    					e.printStackTrace();
    	    				}

    					} catch (IOException e) {
    						// TODO Auto-generated catch block
    						e.printStackTrace();
    					}
    					
    					
    				} catch (IOException e) {
    					// TODO Auto-generated catch block
    					e.printStackTrace();
    				}
                    
                } catch (FileNotFoundException e) {
                    e.printStackTrace();
                } catch (IOException e) {

                    e.printStackTrace();
                }
            }
            
			if (bitmap != null) {
            	StyleSrc[positions]=1;
	    		mGallery01.setAdapter(new ImageAdapter(GalleryViewPic.this, ChkPic()));
			}
		}else if ((requestCode == TPICTURE ) && (resultCode == RESULT_OK)) // Ӭ
		{
			//ContentResolver cr = this.getContentResolver();
			// try
			
			if (data != null) {
				try {					
					Bundle extras = data.getExtras();
					if (extras != null) {
						Bitmap bitmap=null;
							OutPhotoURI = mImageCaptureUri.getPath();
							bitmap = Utilis.getLimitBitmap(mImageCaptureUri.getPath(), 650, 952);
						if (bitmap != null) {
							Matrix matrix = new Matrix();
							ExifInterface exif = new ExifInterface(OutPhotoURI);
							exif = new ExifInterface(OutPhotoURI);
								
							int rotation = exif.getAttributeInt(OutPhotoURI, ExifInterface.ORIENTATION_NORMAL);
							rotationInDegrees = exifToDegrees(rotation);
							matrix.preRotate(rotationInDegrees);
							Bitmap adjustedBitmap = Bitmap.createBitmap(bitmap, 0, 0, 650, 952, matrix, true);
							mBitmap=adjustedBitmap;
							//઺SOURCE_CODE							
						}else{ //
							mBitmap=null;	
							mImagePath = null;
						}
						 //eventImgCrop(OutPhotoURI);
					}
				} catch (Exception e) {
				}
			} else {
				try {
					OutPhotoURI = mImageCaptureUri.getPath();
					Bitmap bitmap = Utilis.getLimitBitmap(OutPhotoURI, 650, 952);
					if (bitmap != null) {
						
						Matrix matrix = new Matrix();
						ExifInterface exif = new ExifInterface(OutPhotoURI);
						int rotation = exif.getAttributeInt(ExifInterface.TAG_ORIENTATION, ExifInterface.ORIENTATION_NORMAL);
						rotationInDegrees = exifToDegrees(rotation);
						
						matrix.preRotate(rotationInDegrees);
						Bitmap adjustedBitmap = Bitmap.createBitmap(bitmap, 0, 0, bitmap.getWidth(), bitmap.getHeight(), matrix, true);
						
						ByteArrayOutputStream stream = new ByteArrayOutputStream();
						adjustedBitmap.compress(Bitmap.CompressFormat.JPEG, 100, stream);// (0 - 100)
				        FileOutputStream fos = null;
						try {
								fos = new FileOutputStream(OutPhotoURI);
						} catch (FileNotFoundException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						
						try {
							adjustedBitmap.compress(CompressFormat.JPEG, 100, fos);
							fos.close();
							mBitmap=adjustedBitmap;
							
						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
					}
				} catch (Exception e) {
				}
			}
			
			
			if (mBitmap!=null){
				if (positions==0)	positionP();
				Apicstr[positions]=OutPhotoURI;
            	StyleSrc[positions]=1;
	    		mGallery01.setAdapter(new ImageAdapter(GalleryViewPic.this, ChkPic()));
			}
		}
	}
	
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		DisplayMetrics dm = new DisplayMetrics();
        getWindowManager().getDefaultDisplay().getMetrics(dm);
        Wwidth = dm.widthPixels;
        Wheight = dm.heightPixels;
		
		setContentView(R.layout.gallerypic);
		mGallery01 = (Gallery) findViewById(R.id.myGallery1);
		mImage = (ImageView) findViewById(R.id.imageView105);

		mImage.getLayoutParams().width=(int) (Wwidth/4);
		mImage.getLayoutParams().height=(int) (Wheight/3.5);

    	mTextView01 = (TextView) findViewById(R.id.textViewg1);
		mTextView02 = (TextView) findViewById(R.id.textViewg2);
		mTextView03 = (TextView) findViewById(R.id.textViewg3);
		mTextView04 = (TextView) findViewById(R.id.textViewg4);
		mTextView05 = (TextView) findViewById(R.id.textViewg5);

    	Bundle bundle = this.getIntent().getExtras();
		String fromW=bundle.getString("GalleryPic");
		String[] arrayW = fromW.split(",");
		batch=arrayW[0];
		goods=arrayW[1];
		filepath+=File.separator+batch+File.separator;        
		getTypeData(this);
		getCountryData(this);

		//DCIM/CWBuyer/batch
        File myDataPath = new File(filepath);
        if (!myDataPath.exists()) myDataPath.mkdirs();  //Ysb hإߤ

        SQLiteDatabase db = Utilis.getDB(this);
		Cursor cs = null;
		StringBuffer mySqlBuf = new StringBuffer();
		//ߤ@ӫ~
		mySqlBuf.append("select PIC from qdetail");
		mySqlBuf.append(" where GOODSNO ='" + goods+"' and BATCH='"+batch+"'");
		cs = db.rawQuery(mySqlBuf.toString(), null);
			if (cs.getCount() > 0) {
				cs.moveToFirst();
				goodsPic=cs.getString(cs.getColumnIndex("PIC"));
			} else {
				db.close();
				finish();
			}
	db.close();
	cs.close();

    getInternet(goods);	Display();
	
	
	((Button) findViewById(R.id.btn_gvycam)).setOnClickListener(new Button.OnClickListener(){
		@Override
		public void onClick(View v) { 
			// TODO Auto-generated method stub
			//Ӭ sW@i
			positions=positionP();
			eventImgCapture(TPICTURE);
		}
	});

	((Button) findViewById(R.id.btn_gvycatch)).setOnClickListener(new Button.OnClickListener(){
		@Override
		public void onClick(View v) {
			// TODO Auto-generated method stub
			positions=positionP();
			eventImgFile();
		}
	});
	
	((Button) findViewById(R.id.btn_gvyexit)).setOnClickListener(new Button.OnClickListener(){
		@Override
		public void onClick(View v) {
			// TODO Auto-generated method stub
	              finish();
		}
	});


	
	mGallery01.setOnItemLongClickListener(new OnItemLongClickListener(){

		@Override
		public boolean onItemLongClick(AdapterView<?> arg0, View arg1,
				int position, long arg3) {
			// TODO Auto-generated method stub
			Utilis.runVibrate(GalleryViewPic.this);
			positions=position;
			//ӬۥHs褧 ۥs褧  
			DialogMenu[0]="Ӭ-"+menu_Y[StyleSrc[positions]];
			DialogMenu[1]="ۥ-"+menu_Y[StyleSrc[positions]];
			DialogUtilis.showDialog(GalleryViewPic.this, "пܥHU\", -1,
					DialogMenu, new IDialog() {
						@Override
						public void onDialogFinish(int pos, String choice) {
							switch (pos) {
								case 0: //s-Ӭ
								{
									eventImgCapture(TPICTURE);
								break;	
								}
								case 1: //s-ۥ
								{
									eventImgFile();
									
								break;	
								}
								case 2: //
								{
									StyleSrc[positions]=0;
									Utilis.DeleteFile(Apicstr[positions]);
									Apicstr[positions]="";
						    		mGallery01.setAdapter(new ImageAdapter(GalleryViewPic.this, ChkPic()));
								break;	
								}
								case 3: //^
								{
								break;	
								}
							}
						}
				});
			
				return true;
		}
	});

	
	mGallery01.setOnItemClickListener(new Gallery.OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> parent, View v,
					int position, long ids) {
				// TODO Auto-generated method stub
				Utilis.runVibrate(GalleryViewPic.this);
				positions=position;
				//ӬۥHs褧 ۥs褧  
				DialogMenu[0]="Ӭ-"+menu_Y[StyleSrc[positions]];
				DialogMenu[1]="ۥ-"+menu_Y[StyleSrc[positions]];
				DialogUtilis.showDialog(GalleryViewPic.this, "пܥHU\", -1,
						DialogMenu, new IDialog() {
							@Override
							public void onDialogFinish(int pos, String choice) {
								switch (pos) {
									case 0: //s-Ӭ
									{
										eventImgCapture(TPICTURE);
									break;	
									}
									case 1: //s-ۥ
									{
										eventImgFile();
										
									break;	
									}
									case 2: //
									{
										StyleSrc[positions]=0;
										Utilis.DeleteFile(Apicstr[positions]);
										Apicstr[positions]="";
							    		mGallery01.setAdapter(new ImageAdapter(GalleryViewPic.this, ChkPic()));
									break;	
									}
									case 3: //^
									{
									break;	
									}
								}
							}
					});
			}
		});

		//s@@յe h\઺
		//ɦLX/l/^ӧ帹
		mImage.setOnClickListener(new ImageView.OnClickListener() {
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				
				Utilis.runVibrate(GalleryViewPic.this);
				DialogUtilis.showDialog(GalleryViewPic.this, "пܥHU\", -1,
						menu_X, new IDialog() {
							@Override
							public void onDialogFinish(int pos, String choice) {
								switch (pos) {
									case 0: //ӫ~l
									{
										Intent intent = new Intent();
										intent.putExtra("QHis_kind", PItemKind.TR10);
										intent.putExtra("QHis_mode", 1);
										intent.putExtra("QHis_User","" );
										intent.putExtra("QHis_Goods",goods );
										intent.setClass(GalleryViewPic.this, QHis.class);
										startActivity(intent);
										
									break;	
									}
									case 1: //^
									{
									break;	
									}
								}
							}
					});
			}
		});
		
	}		
	
	private void getInternet(String mGoods){
		
		File f = new File(filepath);        
		File file[] = f.listFiles();
		Apicstr = new String[maxRec];
		StyleSrc = new int[maxRec];
		int getPic=-1;
		for (int i=0; i < file.length; i++)
		{//Rwsbɮ
			//åBɦWtӳf
			if (file[i].toString().indexOf(goods+"_")>=0){
				//ܩҦwsb_Bưf
				getPic+=1;
				Apicstr[getPic]=file[i].toString();
				StyleSrc[getPic]=1;
			}
		}
		mGallery01.setAdapter(new ImageAdapter(GalleryViewPic.this, ChkPic()));
	}

	private int positionP(){
		int position=-1;
		for (int x=0;x<maxRec;x++){
			if (StyleSrc[x]==1){
				positions+=1;
			}else{
				positions=x;
				break;
			}
		}
		position=positions;
		return position;
	}
	
	
	private List<String> ChkPic() {
		/* ]wثeҦb| */
		List<String> it = new ArrayList<String>();
		/* NҦɮץ[JArrayList */
		for (int i = 0; i < maxRec; i++) {
			if (getImageFile(Apicstr[i]))
				it.add(Apicstr[i]);
			else {it.add(filepath+"0916961962.png");}
		}
		return it;
	}

	private boolean getImageFile(String fName) {
		boolean re;
		if (fName!=null &&fName.length()>0){
			/* oɦW */
			String end = fName.substring(fName.lastIndexOf(".") + 1, fName.length()).toLowerCase();
	
			/* ̪ɦWMwMimeType */
			if (end.equals("jpg") || end.equals("gif") || end.equals("png")
					|| end.equals("jpeg") || end.equals("bmp")) {
				re = true;
			} else	re = false;
		}else re = false;
		return re;
	}
	
	/* gBaseAdapterۭq@ImageAdapter class */
	public class ImageAdapter extends BaseAdapter {
		/* ŧiܼ */
		int mGalleryItemBackground;
		private Context mContext;
		private List<String> lis;

		/* ImageAdapterغcl */
		public ImageAdapter(Context c, List<String> li) {
			mContext = c;
			lis = li;
			/*
			 * ϥΦbres/values/attrs.xml<declare-styleable>wq Galleryݩ.
			 */
			TypedArray a = obtainStyledAttributes(R.styleable.Gallery);
			/* oGalleryݩʪIndex id */
			mGalleryItemBackground = a.getResourceId(
					R.styleable.Gallery_android_galleryItemBackground, 0);
			/* styleableݩʯШϥ */
			a.recycle();
		}

		/* @wnмgkgetCount,Ǧ^Ϥƥ */
		public int getCount() {
			return lis.size();
		}

		/* @wnмgkgetItem,Ǧ^position */
		public Object getItem(int position) {
			return position;
		}

		/* @wnмgkgetItemId,Ǧ^position */
		public long getItemId(int position) {
			return position;
		}

		/* @wnмgkgetView,Ǧ^@View */
		public View getView(int position, View convertView, ViewGroup parent) {
			/* ImageView */
			ImageView i = new ImageView(mContext);
			/* ]wϤimageView */
				Bitmap bm = Utilis.getLimitBitmap(lis.get(position).toString(), 650, 952);
				i.setImageBitmap(bm);

			/* s]wϤe */
			i.setScaleType(ImageView.ScaleType.FIT_XY);
			/* ]wGalleryI */
			i.setBackgroundResource(mGalleryItemBackground);
			/* Ǧ^imageView */
			return i;
		}
	}
	
	
		/* sW@ImageAdapteró]wGallery */

//ƥzXaO	
	public void getCountryData(Context context){
		if(mCountryIdList != null){
			mCountryIdList.clear();
		}
		if(mCountryList != null){
			mCountryList.clear();
		}
		SQLiteDatabase dbs = Utilis.getDB(context);
		Cursor cursor = dbs.rawQuery("select NAME,_ID from qc_country order by _ID", null);
		if(cursor != null){
			try{
				if(cursor.getCount() > 0){
					cursor.moveToFirst();
					for(int i = 0; i < cursor.getCount(); i++){
						int id = cursor.getInt(cursor.getColumnIndex("_ID"));						
						String name = cursor.getString(cursor.getColumnIndex("NAME"));
						mCountryIdList.add(id);
						mCountryList.add(name);
						cursor.moveToNext();
					}
				}
			}catch(Exception e){
				
			}finally{
				cursor.close();
				cursor = null;
			}
		}
		dbs.close();
		dbs = null;
	}
	
	// oO
	public void getTypeData(Context context){
		if(mTypeList != null){
			mTypeList.clear();
		}
		if(mTypeIdList != null){
			mTypeIdList.clear();
		}
		SQLiteDatabase dbs = Utilis.getDB(context);
		Cursor cursor = dbs.rawQuery("select GOODTYPE,_ID from qc_type order by _ID", null);
		if(cursor != null){
			try{
				if(cursor.getCount() > 0){
					cursor.moveToFirst();
					for(int i = 0; i < cursor.getCount(); i++){
						String name = cursor.getString(cursor.getColumnIndex("GOODTYPE"));
						int id = cursor.getInt(cursor.getColumnIndex("_ID"));
						mTypeList.add(name);
						mTypeIdList.add(id);
						cursor.moveToNext();
					}
				}
			}catch(Exception e){
				
			}finally{
				cursor.close();
				cursor = null;
			}
		}
		dbs.close();
		dbs = null;
	}
	
	
	private void Display() {
        SQLiteDatabase db = Utilis.getDB(this);		
		Cursor cs = null;
		StringBuffer mySqlBuf = new StringBuffer();
		mySqlBuf.append("select GOODSNO,GOODSNAME,GOODSTYPE,COUNTRY,")
		.append("BATCH,SUPPLY,SOURCENO,P0,P1,P2,P3,P4,P5,COLORNO,COLOR,SIZE,INLIST,PS")
		.append(" from qdetail where GOODSNO='" + goods+"' and BATCH='"+batch+"'");
		cs = db.rawQuery(mySqlBuf.toString(), null);
		if (cs.getCount()>0){
			cs.moveToFirst();
						mTextView01.setText(cs.getString(cs.getColumnIndex("GOODSNO")));		
						mTextView02.setText(cs.getString(cs.getColumnIndex("GOODSNAME")));
						
						int gtype = cs.getInt(cs.getColumnIndex("GOODSTYPE"));  //Nഫr
				        	int index = mTypeIdList.indexOf(gtype);
				        	if(index >= 0){	mTextView03.setText(mTypeList.get(index));	}
				        	else {
				        		mTextView03.setText(cs.getString(cs.getColumnIndex("GOODSTYPE")));
				        	}
						
						int gcountry= cs.getInt(cs.getColumnIndex("COUNTRY"));   //Nഫr
							int cindex = mCountryIdList.indexOf(gcountry);
							if(cindex>=0){mTextView04.setText(mCountryList.get(cindex));}
							else {
								mTextView04.setText(cs.getString(cs.getColumnIndex("COUNTRY")));
							}
						mTextView05.setText(cs.getString(cs.getColumnIndex("COLOR")));
					
			//s@qBzCؤo-}l			
			//o4ո ⸹ W ؤo ƶq			
			}

			
			Bitmap bm = Utilis.getLimitBitmap(goodsPic, 200,200);
			
			if (bm!=null){	
				reflactionBitmap = createReflectionBitmap(bm);
				mImage.setImageBitmap(reflactionBitmap);
				AnimationSet animation = new AnimationSet(true);
				animation.addAnimation(new AlphaAnimation(0.0F, 1.0F));
				animation.addAnimation(new TranslateAnimation(30, 0, 10, 0));
				animation.setDuration(1000);
				mImage.startAnimation(animation);
			}
		cs.close();
		db.close();
	}

	private void eventImgCapture(int PHOTO) {
		Toast.makeText(GalleryViewPic.this, "۾ШϥΪ", Toast.LENGTH_SHORT).show();
		Intent intent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
		// Wysie_Soh: Create path for temp file
		//batch = ((EditText) findViewById(R.id.edit_batch)).getText().toString();
        if (StyleSrc[positions]==0){//ADD
    		File folder = new File(SAVE_FOLDER);
    		if (folder.exists() == false) folder.mkdirs();
        	mImagePath=filepath+goods+"_"+ String.valueOf(DateUtil.getSystemTime()).substring(12)+ ".jpg";
        }else{//EDIT ϥέӪɦW
        	mImagePath=Apicstr[positions];
        }

        File file = new File(mImagePath);
		mImageCaptureUri = Uri.fromFile(file);

		intent.putExtra(android.provider.MediaStore.EXTRA_OUTPUT,	mImageCaptureUri);

		try {
			intent.putExtra("return-data", true);
			startActivityForResult(intent, PHOTO);
		} catch (ActivityNotFoundException e) {
			// Do nothing for now
		} catch (Exception e) {
		}
	}

	
	public String getPath(Uri uri) {
        if( uri == null ) {
            return null;
        }
        String[] projection = { MediaStore.Images.Media.DATA };
        Cursor cursor = managedQuery(uri, projection, null, null, null);
        if( cursor != null ){
            int column_index = cursor
            .getColumnIndexOrThrow(MediaStore.Images.Media.DATA);
            cursor.moveToFirst();
            return cursor.getString(column_index);
        }
        return uri.getPath();
}
	
	private static int exifToDegrees(int exifOrientation) {        
	    if (exifOrientation == ExifInterface.ORIENTATION_ROTATE_90) { return 90; } 
	    else if (exifOrientation == ExifInterface.ORIENTATION_ROTATE_180) {  return 180; } 
	    else if (exifOrientation == ExifInterface.ORIENTATION_ROTATE_270) {  return 270; }
	    return nPicDegree;    
	 }

	private void eventImgFile() {
		
		Intent intent = new Intent();
		// oۤ^e 
        intent.setType("image/*");
        intent.setAction(Intent.ACTION_GET_CONTENT);
        startActivityForResult(Intent.createChooser(intent,"Select Picture"),SELECT_PICTURE);
	}

	
   	public int[] toInt(Set<Integer> set) {
	    		int[] a = new int[set.size()];
	    		int i = 0;
	    		for (Integer val : set)
	    			a[i++] = val;
	    		return a;
   	}
   	
	public static Bitmap createReflectionBitmap(Bitmap src) {
		// lϤPϮgϤ
		int margin = 4;
		int width = src.getWidth();
		int height = src.getHeight();

		// ΨӰWUA˪Matrix
		Matrix matrix = new Matrix();
		matrix.preScale(1.0f, -1.2f);

		// HlϤUbA˹LӲBitmap
		Bitmap reflection;
		reflection = Bitmap.createBitmap(src, 0, height / 2, width, height / 2,
				matrix, true);
		// ͭlϤPϮgϤX᪺GϤBitmap
		// o٬OŪ
		Bitmap result;
		result = Bitmap.createBitmap(width, height + height / 5,
				Config.ARGB_8888);
		// ϥεe
		Canvas canvas;
		canvas = new Canvas(result);
		// NlϤg쵲GϤeW
		canvas.drawBitmap(src, 0, 0, null);
		// NϮgϤg쵲GϤeW
		canvas.drawBitmap(reflection, 0, height + margin, null);

		// o̤wgPϮgϤX駹F
		// UӭnHƳBz
		Paint paint = new Paint();
		// ϥLinearGradientoӪuVh
		LinearGradient shader;
		// s@Jzh
		// 0x90ffffff(yLz) -> 0x00FFFFFF(z)
		shader = new LinearGradient(0, height, 0, result.getHeight() + margin,
				0x80ffffff, 0x00ffffff, TileMode.CLAMP);
		// ]~ShaderOAҥHϥsetShader]wPaintC
		paint.setShader(shader);
		// wCഫҦ
		paint.setXfermode(new PorterDuffXfermode(Mode.DST_IN));
		// yøh
		canvas.drawRect(0, height, width, result.getHeight(), paint);

		return result;
	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
	}

	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();
	}

	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
//		db.close();
	}

}
